Index: trunk/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 5)
@@ -1,2 +1,34 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
 
 
@@ -36,5 +68,5 @@
   m_ppcResPredTmp  = new TComYuv*[m_uhTotalDepth-1];
 
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
   m_puhDepthSaved  = new UChar[1ll<<( ( m_uhTotalDepth - 1 )<<1 )];
   m_puhWidthSaved  = new UChar[1ll<<( ( m_uhTotalDepth - 1 )<<1 )];
@@ -77,5 +109,5 @@
   Int i;
 
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
   delete[] m_puhDepthSaved;  m_puhDepthSaved  = NULL;
   delete[] m_puhWidthSaved;  m_puhWidthSaved  = NULL;
@@ -245,5 +277,5 @@
 
 
-//GT VSO
+#if HHI_VSO
       if ( m_pcRdCost->getUseLambdaScaleVSO() )
       {
@@ -251,8 +283,9 @@
       }
       else
+#endif
       {
         m_ppcBestCU[0]->getTotalCost()  = m_pcRdCost->calcRdCost( m_ppcBestCU[0]->getTotalBits(), m_ppcBestCU[0]->getTotalDistortion() );
       }
-//GT VSO end
+
       fBestCost = m_ppcBestCU[0]->getTotalCost();
 
@@ -276,5 +309,5 @@
         m_ppcBestCU[0]->getTotalBits() += m_pcEntropyCoder->getNumberOfWrittenBits(); // dQP bits
 
-        //GT VSO
+#if HHI_VSO
         if (m_pcRdCost->getUseLambdaScaleVSO())
         {
@@ -282,8 +315,8 @@
         }
         else
+#endif
         {
           m_ppcBestCU[0]->getTotalCost()  = m_pcRdCost->calcRdCost( m_ppcBestCU[0]->getTotalBits(), m_ppcBestCU[0]->getTotalDistortion() );
         }
-        //GT VSO end
 
         if ( fBestCost > m_ppcBestCU[0]->getTotalCost() )
@@ -309,5 +342,5 @@
       m_ppcBestCU[0]->getTotalBits() += m_pcEntropyCoder->getNumberOfWrittenBits(); // dQP bits
 
-      //GT VSO
+#if HHI_VSO
       if (m_pcRdCost->getUseLambdaScaleVSO())
       {
@@ -315,8 +348,8 @@
       }
       else
+#endif
       {
         m_ppcBestCU[0]->getTotalCost()  = m_pcRdCost->calcRdCost( m_ppcBestCU[0]->getTotalBits(), m_ppcBestCU[0]->getTotalDistortion() );
       }
-     //GT VSO end
     }
   }
@@ -415,5 +448,5 @@
   UInt uiBPelY   = uiTPelY + rpcBestCU->getHeight(0) - 1;
 
-#if ( SB_INTERVIEW_SKIP)
+#if ( HHI_INTERVIEW_SKIP)
   Bool bFullyRenderedSec = true ;
   if( m_pcEncCfg->getInterViewSkip() )
@@ -445,5 +478,5 @@
     bFullyRenderedSec = false ;
   }
-#if SB_INTERVIEW_SKIP_LAMBDA_SCALE
+#if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
   if( bFullyRenderedSec )
   {
@@ -463,4 +496,5 @@
     if( rpcBestCU->getSlice()->getSliceType() != I_SLICE )
     {
+#if HHI_INTER_VIEW_RESIDUAL_PRED
       // check availability of residual prediction
       Bool  bResPredAvailable   = false;
@@ -476,4 +510,5 @@
       {
         Bool bResPredFlag  = ( uiResPrdId > 0 );
+#endif
 
       // SKIP
@@ -483,9 +518,13 @@
       {
 #if !HHI_MRG_SKIP
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
+#endif
         xCheckRDCostAMVPSkip ( rpcBestCU, rpcTempCU );        rpcTempCU->initEstData();
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
         xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU, bFullyRenderedSec );            rpcTempCU->initEstData();
 #else
@@ -495,5 +534,7 @@
       else
       {
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
+#endif
         xCheckRDCostAMVPSkip ( rpcBestCU, rpcTempCU );        rpcTempCU->initEstData();
       }
@@ -514,6 +555,8 @@
       {
 #if HHI_DISABLE_INTER_NxN_SPLIT
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
         xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec );  rpcTempCU->initEstData();
 #else
@@ -522,6 +565,8 @@
         if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth )
         {
+#if HHI_INTER_VIEW_RESIDUAL_PRED
           rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
           xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec );  rpcTempCU->initEstData();
 #else
@@ -530,12 +575,16 @@
         }
 #else
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
         xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec );  rpcTempCU->initEstData();
 #else
         xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );  rpcTempCU->initEstData();
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
         xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_NxN, bFullyRenderedSec   );  rpcTempCU->initEstData();
 #else
@@ -549,12 +598,16 @@
 #endif
       { // 2NxN, Nx2N
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
         xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_Nx2N, bFullyRenderedSec  );  rpcTempCU->initEstData();
 #else
         xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_Nx2N  );  rpcTempCU->initEstData();
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
         rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
         xCheckRDCostInter      ( rpcBestCU, rpcTempCU, SIZE_2NxN, bFullyRenderedSec  );  rpcTempCU->initEstData();
 #else
@@ -563,5 +616,7 @@
       }
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
     } // uiResPrdId
+#endif
     }
 
@@ -570,5 +625,5 @@
     {
       // speedup for inter frames
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
       if( ( rpcBestCU->getSlice()->getSliceType() == I_SLICE ||
                rpcBestCU->getCbf( 0, TEXT_LUMA     ) != 0   ||
@@ -596,12 +651,8 @@
 
     m_pcEntropyCoder->resetBits();
-#if MW_MVI_SIGNALLING_MODE == 0
-    if( rpcBestCU->getSlice()->getSPS()->getUseMVI() && rpcBestCU->getSlice()->getSliceType() != I_SLICE )
-      m_pcEntropyCoder->encodeMvInheritanceFlag( rpcBestCU, 0, uiDepth, true );
-#endif
     m_pcEntropyCoder->encodeSplitFlag( rpcBestCU, 0, uiDepth, true );
     rpcBestCU->getTotalBits() += m_pcEntropyCoder->getNumberOfWrittenBits(); // split bits
 
-    //GT VSO
+#if HHI_VSO
     if (m_pcRdCost->getUseLambdaScaleVSO())
     {
@@ -609,6 +660,7 @@
     }
     else
-    {
-#if SB_INTERVIEW_SKIP
+#endif
+    {
+#if HHI_INTERVIEW_SKIP
   if(  m_pcEncCfg->getInterViewSkip())
       {
@@ -631,5 +683,5 @@
       rpcBestCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcBestCU->getTotalBits(), rpcBestCU->getTotalDistortion() );
     }
-    //GT VSO end
+    
 
     // accumulate statistics for early skip
@@ -643,10 +695,5 @@
       }
     }
-#if MW_MVI_SIGNALLING_MODE == 0
-    if( rpcBestCU->getSlice()->getSPS()->getUseMVI() && rpcBestCU->getSlice()->getSliceType() != I_SLICE )
-    {
-      xCheckRDCostMvInheritance( rpcBestCU, rpcTempCU, uiDepth, false );  rpcTempCU->initEstData();
-    }
-#elif MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
     if( rpcBestCU->getSlice()->getSPS()->getUseMVI() && rpcBestCU->getSlice()->getSliceType() != I_SLICE )
     {
@@ -666,4 +713,5 @@
   if( bTrySplit && uiDepth < g_uiMaxCUDepth - g_uiAddCUDepth )
   {
+#if HHI_VSO
     // reset Model
     if( m_pcRdCost->getUseRenModel() )
@@ -675,4 +723,5 @@
       m_pcRdCost->setRenModelData( m_ppcBestCU[uiDepth], 0, piSrc, uiSrcStride, uiWidth, uiHeight );
     }
+#endif
 
     UChar       uhNextDepth         = uiDepth+1;
@@ -701,4 +750,5 @@
         xCompressCU( pcSubBestPartCU, pcSubTempPartCU, uhNextDepth );
 
+#if HHI_VSO
         if( m_pcRdCost->getUseRenModel() )
         {
@@ -709,4 +759,5 @@
           m_pcRdCost->setRenModelData( pcSubBestPartCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
         }
+#endif
         rpcTempCU->copyPartFrom( pcSubBestPartCU, uiPartUnitIdx, uhNextDepth );         // Keep best part data to current temporary data.
         xCopyYuv2Tmp( pcSubBestPartCU->getTotalNumPart()*uiPartUnitIdx, uhNextDepth );
@@ -718,13 +769,9 @@
       m_pcEntropyCoder->resetBits();
       m_pcEntropyCoder->encodeSplitFlag( rpcTempCU, 0, uiDepth, true );
-#if MW_MVI_SIGNALLING_MODE == 0
-      if( rpcBestCU->getSlice()->getSPS()->getUseMVI() && rpcBestCU->getSlice()->getSliceType() != I_SLICE )
-        m_pcEntropyCoder->encodeMvInheritanceFlag( rpcTempCU, 0, uiDepth, true );
-#endif
 
       rpcTempCU->getTotalBits() += m_pcEntropyCoder->getNumberOfWrittenBits(); // split bits
     }
 
-#if SB_INTERVIEW_SKIP_LAMBDA_SCALE
+#if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
     if( bFullyRenderedSec )
     {
@@ -736,5 +783,5 @@
     }
 #endif
-//GT VSO
+#if HHI_VSO
     if ( m_pcRdCost->getUseLambdaScaleVSO())
     {
@@ -742,8 +789,8 @@
     }
     else
+#endif
     {
       rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
     }
-//GT VSO end
 
     if( m_bUseSBACRD )
@@ -753,4 +800,5 @@
     xCheckBestMode( rpcBestCU, rpcTempCU, uiDepth );                                          // RD compare current larger prediction
 
+#if HHI_VSO
     if( m_pcRdCost->getUseRenModel() )
     {
@@ -761,4 +809,5 @@
       m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
     }
+#endif
   }                                                                                  // with sub partitioned prediction.
 
@@ -793,13 +842,9 @@
   UInt uiBPelY   = uiTPelY + (g_uiMaxCUHeight>>uiDepth) - 1;
 
-#if MW_MVI_SIGNALLING_MODE == 0
-  if( pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE )
-  {
-    m_pcEntropyCoder->encodeMvInheritanceFlag( pcCU, uiAbsPartIdx, uiDepth );
-  }
-#endif
   if( ( uiRPelX < pcCU->getSlice()->getSPS()->getWidth() ) && ( uiBPelY < pcCU->getSlice()->getSPS()->getHeight() ) )
   {
+#if HHI_MPI
     if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 || uiDepth < pcCU->getTextureModeDepth( uiAbsPartIdx ) )
+#endif
       m_pcEntropyCoder->encodeSplitFlag( pcCU, uiAbsPartIdx, uiDepth );
   }
@@ -809,5 +854,5 @@
   }
 
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
   if( uiDepth == pcCU->getTextureModeDepth( uiAbsPartIdx ) )
   {
@@ -870,5 +915,9 @@
 #endif
 
+#if HHI_MPI
   if( !pcCU->getSlice()->isIntra() && pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 )
+#else
+  if( !pcCU->getSlice()->isIntra() )
+#endif
   {
     m_pcEntropyCoder->encodeSkipFlag( pcCU, uiAbsPartIdx );
@@ -889,9 +938,13 @@
     }
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
     m_pcEntropyCoder->encodeResPredFlag( pcCU, uiAbsPartIdx, 0 );
+#endif
     return;
   }
+#if HHI_MPI
   if( pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 )
   {
+#endif
     m_pcEntropyCoder->encodePredMode( pcCU, uiAbsPartIdx );
 
@@ -901,9 +954,13 @@
     m_pcEntropyCoder->encodePredInfo( pcCU, uiAbsPartIdx );
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
     if( !pcCU->isIntra( uiAbsPartIdx ) )
     {
       m_pcEntropyCoder->encodeResPredFlag( pcCU, uiAbsPartIdx, 0 );
     }
-  }
+#endif
+#if HHI_MPI
+  }
+#endif
 
   // Encode Coefficients
@@ -915,4 +972,5 @@
   UChar uhDepth = rpcTempCU->getDepth( 0 );
 
+#if HHI_VSO
   if( m_pcRdCost->getUseRenModel() )
   {
@@ -923,4 +981,5 @@
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 
   rpcTempCU->setPredModeSubParts( MODE_SKIP,   0, uhDepth );
@@ -950,5 +1009,5 @@
  * \returns Void
  */
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
 Void TEncCu::xCheckRDCostMerge2Nx2N( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, Bool bSkipRes )
 #else
@@ -961,6 +1020,8 @@
   UInt uiNeighbourCandIdx[MRG_MAX_NUM_CANDS]; //MVs with same idx => same cand
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   Bool  bResPrdAvail  = rpcTempCU->getResPredAvail( 0 );
   Bool  bResPrdFlag   = rpcTempCU->getResPredFlag ( 0 );
+#endif
 
   for( UInt ui = 0; ui < MRG_MAX_NUM_CANDS; ++ui )
@@ -971,4 +1032,5 @@
   UChar uhDepth = rpcTempCU->getDepth( 0 );
 
+#if HHI_VSO
   if( m_pcRdCost->getUseRenModel() )
   {
@@ -979,4 +1041,5 @@
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 
   rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N, 0, uhDepth ); // interprets depth relative to LCU level
@@ -990,5 +1053,5 @@
 #if HHI_MRG_SKIP
       TComYuv* pcPredYuvTemp = NULL;
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
       for( UInt uiNoResidual = (bSkipRes ? 1:0); uiNoResidual < 2; ++uiNoResidual )
 #else
@@ -1015,10 +1078,12 @@
       rpcTempCU->getCUMvField( REF_PIC_LIST_1 )->setAllMvField( cMvFieldNeighbours[1 + 2*uiMergeCand].getMv(), cMvFieldNeighbours[1 + 2*uiMergeCand].getRefIdx(), SIZE_2Nx2N, 0, 0, 0 ); // interprets depth relative to rpcTempCU level
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
       rpcTempCU->setResPredAvailSubParts( bResPrdAvail, 0, 0, uhDepth );
       rpcTempCU->setResPredFlagSubParts ( bResPrdFlag,  0, 0, uhDepth );
+#endif
 
 #if HHI_MRG_SKIP
       // do MC
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
       if ( (uiNoResidual == 0) || bSkipRes ){
 #else
@@ -1036,5 +1101,5 @@
         }
       }
-
+#if HHI_VSO
       if( m_pcRdCost->getUseRenModel() )
       { //Reset
@@ -1045,4 +1110,5 @@
         m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
       }
+#endif
 
       // estimate residual and encode everything
@@ -1082,5 +1148,5 @@
 }
 
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
 Void TEncCu::xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bSkipRes)
 #else
@@ -1090,4 +1156,5 @@
   UChar uhDepth = rpcTempCU->getDepth( 0 );
 
+#if HHI_VSO
   if( m_pcRdCost->getUseRenModel() )
   {
@@ -1098,28 +1165,37 @@
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 
   rpcTempCU->setDepthSubParts( uhDepth, 0 );
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   Bool  bResPrdAvail  = rpcTempCU->getResPredAvail( 0 );
   Bool  bResPrdFlag   = rpcTempCU->getResPredFlag ( 0 );
+#endif
   rpcTempCU->setPartSizeSubParts    ( SIZE_2Nx2N,   0,    uhDepth );
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   rpcTempCU->setResPredAvailSubParts( bResPrdAvail, 0, 0, uhDepth );
   rpcTempCU->setResPredFlagSubParts ( bResPrdFlag,  0, 0, uhDepth );
+#endif
   rpcTempCU->setPartSizeSubParts    ( ePartSize,    0,    uhDepth );
   rpcTempCU->setPredModeSubParts    ( MODE_INTER,   0,    uhDepth );
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   if( rpcTempCU->getResPredFlag( 0 ) )
   { // subtract residual prediction from original in motion search
     m_ppcOrigYuv[uhDepth]->add( m_ppcResPredTmp [uhDepth], rpcTempCU->getWidth( 0 ), rpcTempCU->getHeight( 0 ), true );
   }
-  #if SB_INTERVIEW_SKIP
+#endif
+#if HHI_INTERVIEW_SKIP
   m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth], bSkipRes );
 #else
   m_pcPredSearch->predInterSearch ( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcRecoYuvTemp[uhDepth] );
 #endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   if( rpcTempCU->getResPredFlag( 0 ) )
   { // add residual prediction to original again
     m_ppcOrigYuv[uhDepth]->add( m_ppcResPredTmp [uhDepth], rpcTempCU->getWidth( 0 ), rpcTempCU->getHeight( 0 ) );
   }
+#endif
 
 #if PART_MRG
@@ -1129,10 +1205,11 @@
   }
 #endif
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
   m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], m_ppcResPredTmp [uhDepth],bSkipRes );
 #else
   m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], m_ppcResPredTmp [uhDepth], false );
 #endif
-//GT VSO
+
+#if HHI_VSO
   if( m_pcRdCost->getUseLambdaScaleVSO() )
   {
@@ -1140,8 +1217,8 @@
   }
   else
+#endif
   {
     rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
   }
-//GT VSO end
 
   xCheckBestMode( rpcBestCU, rpcTempCU, uhDepth );
@@ -1152,5 +1229,5 @@
   UInt uiDepth = rpcTempCU->getDepth( 0 );
 
-  // reset Model
+#if HHI_VSO
   if( m_pcRdCost->getUseRenModel() )
   {
@@ -1161,4 +1238,5 @@
     m_pcRdCost->setRenModelData( rpcTempCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 
   rpcTempCU->setPartSizeSubParts( eSize, 0, uiDepth );
@@ -1191,5 +1269,5 @@
 
   rpcTempCU->getTotalBits() = m_pcEntropyCoder->getNumberOfWrittenBits();
-//GT VSO
+#if HHI_VSO
   if( m_pcRdCost->getUseLambdaScaleVSO())
   {
@@ -1197,8 +1275,8 @@
   }
   else
+#endif
   {
     rpcTempCU->getTotalCost() = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
   }
-//GT VSO end
 
   xCheckBestMode( rpcBestCU, rpcTempCU, uiDepth );
@@ -1239,6 +1317,8 @@
   UChar uhDepth = rpcTempCU->getDepth(0);
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
   Bool  bResPrdAvail  = rpcTempCU->getResPredAvail( 0 );
   Bool  bResPrdFlag   = rpcTempCU->getResPredFlag ( 0 );
+#endif
 
   AMVPInfo cAMVPInfo0;
@@ -1278,6 +1358,8 @@
       rpcTempCU->setPredModeSubParts( MODE_SKIP, 0, uhDepth );
       rpcTempCU->setPartSizeSubParts( SIZE_2Nx2N,  0, uhDepth );
+#if HHI_INTER_VIEW_RESIDUAL_PRED
       rpcTempCU->setResPredAvailSubParts( bResPrdAvail, 0, 0, uhDepth );
       rpcTempCU->setResPredFlagSubParts ( bResPrdFlag,  0, 0, uhDepth );
+#endif
 
       if (rpcTempCU->getSlice()->isInterB())
@@ -1317,11 +1399,6 @@
 }
 
-#if MW_MVI_SIGNALLING_MODE == 0
-Void TEncCu::xCheckRDCostMvInheritance( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, UChar uhTextureModeDepth, Bool bRecursiveCall )
-#elif MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
 Void TEncCu::xCheckRDCostMvInheritance( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, UChar uhTextureModeDepth, Bool bSkipResidual, Bool bRecursiveCall )
-#else
-#error
-#endif
 {
   assert( rpcTempCU->getSlice()->getSPS()->isDepth() );
@@ -1342,4 +1419,5 @@
   }
 
+#if HHI_VSO
   if( m_pcRdCost->getUseRenModel() && !bRecursiveCall)
   {
@@ -1350,4 +1428,5 @@
     m_pcRdCost->setRenModelData( m_ppcTempCU[uhDepth], 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 
   Bool bSplit = uhDepth < pcTextureCU->getDepth( rpcTempCU->getZorderIdxInCU() );
@@ -1377,9 +1456,5 @@
         }
 
-#if MW_MVI_SIGNALLING_MODE == 0
-        xCheckRDCostMvInheritance( pcSubBestPartCU, pcSubTempPartCU, uhTextureModeDepth, true );
-#elif MW_MVI_SIGNALLING_MODE == 1
         xCheckRDCostMvInheritance( pcSubBestPartCU, pcSubTempPartCU, uhTextureModeDepth, bSkipResidual, true );
-#endif
 
         rpcTempCU->copyPartFrom( pcSubBestPartCU, uiPartUnitIdx, uhNextDepth );         // Keep best part data to current temporary data.
@@ -1408,21 +1483,10 @@
       assert( rpcTempCU->getPredictionMode( ui ) != MODE_NONE );
     }
-#if MW_MVI_SIGNALLING_MODE == 0
-    if( rpcTempCU->getPredictionMode( 0 ) == MODE_SKIP )
-    {
-      rpcTempCU->setPredModeSubParts( MODE_INTER, 0, uhDepth );
-    }
-#elif MW_MVI_SIGNALLING_MODE == 1
     rpcTempCU->setPredModeSubParts( bSkipResidual ? MODE_SKIP : MODE_INTER, 0, uhDepth );
-#endif
     m_pcPredSearch->motionCompensation( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
 
     // get Original YUV data from picture
     m_ppcOrigYuv[uhDepth]->copyFromPicYuv( rpcBestCU->getPic()->getPicYuvOrg(), rpcBestCU->getAddr(), rpcBestCU->getZorderIdxInCU() );
-#if MW_MVI_SIGNALLING_MODE == 0
-    m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], m_ppcResPredTmp [uhDepth], false );
-#elif MW_MVI_SIGNALLING_MODE == 1
     m_pcPredSearch->encodeResAndCalcRdInterCU( rpcTempCU, m_ppcOrigYuv[uhDepth], m_ppcPredYuvTemp[uhDepth], m_ppcResiYuvTemp[uhDepth], m_ppcResiYuvBest[uhDepth], m_ppcRecoYuvTemp[uhDepth], m_ppcResPredTmp [uhDepth], bSkipResidual );
-#endif
 
     if( uhDepth == uhTextureModeDepth )
@@ -1431,5 +1495,6 @@
     }
   }
-  //GT VSO
+
+#if HHI_VSO
   if( m_pcRdCost->getUseLambdaScaleVSO() )
   {
@@ -1437,11 +1502,12 @@
   }
   else
+#endif
   {
     rpcTempCU->getTotalCost()  = m_pcRdCost->calcRdCost( rpcTempCU->getTotalBits(), rpcTempCU->getTotalDistortion() );
   }
-  //GT VSO end
 
   xCheckBestMode( rpcBestCU, rpcTempCU, uhDepth );
 
+#if HHI_VSO
   if( !bSplit && bRecursiveCall && m_pcRdCost->getUseRenModel() )
   {
@@ -1452,4 +1518,5 @@
     m_pcRdCost->setRenModelData( rpcBestCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
   }
+#endif
 }
 
@@ -1458,7 +1525,4 @@
   const UChar uhDepth = pcCU->getTextureModeDepth( 0 );
   m_pcEntropyCoder->resetBits();
-#if MW_MVI_SIGNALLING_MODE == 0
-  m_pcEntropyCoder->encodeMvInheritanceFlag( pcCU, 0, uhDepth, true );
-#elif MW_MVI_SIGNALLING_MODE == 1
   xSaveDepthWidthHeight( pcCU );
   pcCU->setSizeSubParts( g_uiMaxCUWidth>>uhDepth, g_uiMaxCUHeight>>uhDepth, 0, uhDepth );
@@ -1527,10 +1591,8 @@
   }
   xRestoreDepthWidthHeight( pcCU );
-#endif
 
   pcCU->getTotalBits() += m_pcEntropyCoder->getNumberOfWrittenBits();
 }
 
-#if MW_MVI_SIGNALLING_MODE == 1
 Void TEncCu::xSaveDepthWidthHeight( TComDataCU* pcCU )
 {
Index: trunk/source/Lib/TLibEncoder/TEncCu.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCu.h	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncCu.h	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 
 
@@ -68,5 +101,5 @@
   Bool                    m_bUseSBACRD;
   
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
   UChar *m_puhDepthSaved;
   UChar *m_puhWidthSaved;
@@ -99,5 +132,5 @@
   Void  xCheckRDCostAMVPSkip( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU                      );
   
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
   Void xCheckRDCostMerge2Nx2N( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, Bool bFullyRendered ) ;
 #else
@@ -106,5 +139,5 @@
   
   Void  xCheckRDCostSkip    ( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, Bool bBSkipRes      );
-#if SB_INTERVIEW_SKIP
+#if HHI_INTERVIEW_SKIP
   Void xCheckRDCostInter( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, PartSize ePartSize, Bool bFullyRendered ) ;
 #else
@@ -118,7 +151,5 @@
   Void  xCopyYuv2Tmp        ( UInt uhPartUnitIdx, UInt uiDepth );
   Void  xAddMVISignallingBits( TComDataCU* pcCU );
-#if MW_MVI_SIGNALLING_MODE == 0
-  Void  xCheckRDCostMvInheritance( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, UChar uhTextureModeDepth, Bool bRecursiveCall );
-#elif MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
   Void  xCheckRDCostMvInheritance( TComDataCU*& rpcBestCU, TComDataCU*& rpcTempCU, UChar uhTextureModeDepth, Bool bSkipResidual, Bool bRecursiveCall );
   Void  xSaveDepthWidthHeight( TComDataCU* pcCU );
Index: trunk/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 2)
+++ trunk/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 5)
@@ -1,2 +1,35 @@
+/* The copyright in this software is being made available under the BSD
+ * License, included below. This software may be subject to other third party
+ * and contributor rights, including patent rights, and no such rights are
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2011, ISO/IEC
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ *  * Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ *  * Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *    be used to endorse or promote products derived from this software without
+ *    specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
+ * THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
 
 
@@ -408,5 +441,5 @@
     }
   }
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
   if( pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE && pcCU->getPartitionSize( uiAbsPartIdx ) == SIZE_2Nx2N )
     uiNumCand++;
@@ -419,4 +452,5 @@
 
 
+#if HHI_INTER_VIEW_RESIDUAL_PRED
 Void 
 TEncEntropy::encodeResPredFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPUIdx, Bool bRD )
@@ -437,4 +471,5 @@
   m_pcEntropyCoderIf->codeResPredFlag( pcCU, uiAbsPartIdx );
 }
+#endif
 
 
@@ -517,13 +552,4 @@
   m_pcEntropyCoderIf->codeSplitFlag( pcCU, uiAbsPartIdx, uiDepth );
 }
-
-#if MW_MVI_SIGNALLING_MODE == 0
-Void TEncEntropy::encodeMvInheritanceFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth, Bool bRD )
-{
-  if( bRD )
-    uiAbsPartIdx = 0;
-  m_pcEntropyCoderIf->codeMvInheritanceFlag( pcCU, uiAbsPartIdx, uiDepth );
-}
-#endif
 
 /** encode partition size
@@ -1568,5 +1594,5 @@
     {
 #if  HHI_MRG_SKIP
-#if MW_MVI_SIGNALLING_MODE == 1
+#if HHI_MPI
       if( !(pcCU->getMergeFlag( uiAbsPartIdx ) && pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2Nx2N &&
             ( pcCU->getTextureModeDepth( uiAbsPartIdx ) == -1 || uiDepth == pcCU->getTextureModeDepth( uiAbsPartIdx ) ) ) )
